import { defineComponent as g, h as j, toRefs as b, computed as o, openBlock as u, createBlock as m, unref as i, normalizeClass as p, createElementBlock as h, createVNode as L, createElementVNode as D, createCommentVNode as v, renderSlot as $, withModifiers as E } from "vue";
import q from "./assets/987730f7b4fdae15.svg";
const R = g({
  props: {
    /** The rich text field data. */
    field: {
      type: Object,
      default() {
        return {};
      },
      required: !0
    },
    /**
     * The HTML element that will wrap the contents of the field.
     */
    tag: { type: String, default: "div" },
    /**
     * Can be used to explicitly disable inline editing.
     * If true and `field.editable` has a value, then `field.editable` will
     * be processed and rendered as component output.
     * If false, `field.editable` value will be ignored and not rendered.
     */
    editable: { type: Boolean, default: !0 }
  },
  mounted() {
    var e;
    const t = (e = this.$props.field) === null || e === void 0 ? void 0 : e.value, n = this.$props.field && this.$props.field.editable && this.$props.editable;
    t && !n && this.bindRouteLinks();
  },
  methods: {
    /**
     * Click handler for links.
     * @param {MouseEvent} event - event emmited by clicking the link
     */
    routeHandler(e) {
      e.preventDefault();
      let t = e.target;
      t.pathname || (t = t.closest("a"));
      const n = t.hash ? `${t.pathname}${t.hash}` : t.pathname;
      this.$router.push(n);
    },
    /**
     * Extracts anchor elements and adds a custom click event
     * listener to prevent page refresh.
     */
    bindRouteLinks() {
      this.$el.querySelectorAll('a[href^="/"]').forEach((t) => {
        t.removeEventListener("click", this.routeHandler, !1), t.addEventListener("click", this.routeHandler, !1);
      });
    }
  },
  render() {
    const { field: e, tag: t, editable: n } = this.$props;
    if (!e || !e.editable && !e.value)
      return null;
    const s = Object.assign(Object.assign({}, this.$data), { innerHTML: e.editable && n ? e.editable : e.value });
    return j(t, s);
  }
}), O = g({
  props: {
    /** The text field data. */
    field: {
      type: Object,
      default() {
        return {};
      },
      required: !0
    },
    /**
     * The HTML element that will wrap the contents of the field.
     */
    tag: { type: String, default: "span" },
    /**
     * Can be used to explicitly disable inline editing.
     * If true and `field.editable` has a value, then `field.editable` will
     * be processed and rendered as component output. If false, `field.editable` value will be ignored and not rendered.
     */
    editable: { type: Boolean, default: !0 },
    /**
     * If false, HTML-encoding of the field value is disabled and the value is rendered as-is.
     */
    encode: { type: Boolean, default: !0 }
  },
  render() {
    const { field: e, tag: t, editable: n, encode: s } = this.$props;
    if (!e || !e.editable && (e.value === void 0 || e.value === ""))
      return null;
    const l = s ? n : !1, a = e.editable && l ? e.editable : e.value, r = e.editable && l || !s, d = Object.assign({}, this.$data);
    let f = null;
    return r ? d.innerHTML = a : f = a, j(t || "span", d, f);
  }
}), M = /* @__PURE__ */ g({
  __name: "CompBlockquote",
  props: {
    field: {},
    tag: { default: "span" },
    size: { default: "s" }
  },
  setup(e) {
    const t = e, { size: n } = b(t), s = o(() => {
      switch (n.value) {
        case "s":
          return "text-20 sm:text-22 md:text-24 lg:text-28 font-320 sm:font-260 leading-130 sm:leading-120 font-w-45 sm:font-w-60";
        case "l":
          return "text-26 sm:text-40 md:font-48 lg:font-56 leading-130 sm:leading-120 font-320 sm:font-260 font-w-45 sm:font-w-60";
        default:
          return "";
      }
    });
    return (l, a) => (u(), m(i(O), {
      tag: l.tag,
      field: l.field,
      class: p([s.value]),
      "data-quote-size": i(n)
    }, null, 8, ["tag", "field", "class", "data-quote-size"]));
  }
}), I = { class: "prose" }, P = /* @__PURE__ */ g({
  __name: "CompBody",
  props: {
    field: {},
    tag: { default: "div" },
    size: { default: "m" },
    isStrong: { type: Boolean, default: !1 }
  },
  setup(e) {
    const t = e, { size: n, isStrong: s } = b(t), l = o(() => {
      switch (n.value) {
        case "xs":
          return "text-12 lg:text-14 font-w-45 sm:font-w-60 leading-130";
        case "s":
          return "text-14 sm:text-16 lg:text-20 font-w-45 sm:font-w-60 leading-135";
        case "m":
          return "text-16 sm:text-18 md:text-20 lg:text-24 font-w-45 sm:font-w-60 leading-135 sm:leading-140";
        default:
          return "";
      }
    }), a = o(() => {
      if (!s.value)
        switch (n.value) {
          case "xs":
            return "font-360 sm:font-400";
          case "s":
            return "font-300";
          case "m":
            return "font-300 sm:font-240";
          default:
            return "";
        }
      return "font-600 sm:font-560";
    });
    return (r, d) => (u(), h("div", I, [
      L(i(R), {
        tag: r.tag,
        field: r.field,
        class: p([l.value, a.value]),
        "data-body-size": i(n),
        "data-body-bold": i(s)
      }, null, 8, ["tag", "field", "class", "data-body-size", "data-body-bold"])
    ]));
  }
});
function V(e) {
  const { svgSize: t, svgName: n, sprite: s } = e, l = o(() => t / 4), a = o(
    () => `w-${l.value} h-${l.value}`
  ), r = o(() => `${s}#${n}`);
  return { svgFullSize: a, svg: r };
}
const F = ["xlink:href"], x = /* @__PURE__ */ g({
  __name: "SvgGlyph",
  props: {
    name: { default: "placeholder" },
    size: { default: 16 }
  },
  setup(e) {
    const t = e, { name: n, size: s } = b(t), { svg: l, svgFullSize: a } = V({ svgName: n.value, svgSize: s.value, sprite: q });
    return (r, d) => (u(), h("svg", {
      class: p(i(a))
    }, [
      D("use", { "xlink:href": i(l) }, null, 8, F)
    ], 2));
  }
}), Q = ["href", "target", "data-variant"], A = ["disabled", "data-variant", "onClick"], G = /* @__PURE__ */ g({
  __name: "CompButton",
  props: {
    href: { default: "" },
    link: { default: "" },
    target: { default: "_self" },
    isDisabled: { type: Boolean, default: !1 },
    onDark: { type: Boolean, default: !1 },
    variant: { default: "primary" },
    iconPosition: { default: "" },
    iconOnly: { type: Boolean, default: !1 },
    size: { default: "m" },
    iconName: { default: "" }
  },
  emits: ["handleClick"],
  setup(e, { emit: t }) {
    const n = e, s = t, { size: l, variant: a, onDark: r, isDisabled: d, iconOnly: f, iconPosition: y } = b(n), k = o(() => {
      if (a.value !== "link")
        return f.value ? l.value === "m" ? "px-4" : "px-2" : l.value === "m" ? "px-6" : "px-4";
    }), z = o(() => a.value === "link" ? l.value === "m" ? "font-360 font-w-60 text-16 h-12" : "font-360 font-w-60 text-12 h-8" : l.value === "m" ? "font-600 font-w-60 text-14 h-12" : "font-600 font-w-60 text-11 h-8"), w = o(() => {
      if (a.value !== "link")
        return "uppercase";
    }), _ = o(() => {
      if (a.value === "primary")
        return d.value ? r.value ? "bg-velux-grey-800 text-velux-grey-400 pointer-events-none" : "bg-velux-grey-200 text-velux-grey-500 pointer-events-none" : r.value ? "bg-velux-white text-velux-black hover:bg-velux-grey-400" : "bg-velux-red-800 hover:bg-velux-red-900 text-velux-white cursor-pointer";
      if (a.value === "secondary")
        return d.value ? r.value ? "text-velux-grey-800 border border-velux-grey-800" : "bg-velux-white text-velux-grey-200 border border-velux-grey-200 " : r.value ? "bg-transparent text-velux-white border border-velux-white hover:text-velux-black hover:bg-velux-white" : "bg-velux-white text-velux-black border border-velux-black hover:bg-velux-grey-400 cursor-pointer";
      if (a.value === "link")
        return d.value ? r.value ? "text-velux-grey-800" : "text-velux-grey-200" : r.value ? "hover:text-velux-blue-600 text-velux-white" : "hover:text-velux-blue-600 text-velux-black";
    }), S = o(() => y.value === "leading" || f.value), B = o(() => y.value === "trailing"), C = o(() => {
      if (l.value === "s" && a.value === "link")
        return 10;
    }), T = o(() => !f.value), H = () => s("handleClick");
    return (c, X) => c.href ? (u(), h("a", {
      key: 0,
      href: c.link,
      target: c.target,
      class: p(["inline-flex items-center leading-115 gap-x-2 justify-center tracking-1", [w.value, z.value, _.value, k.value]]),
      "data-variant": i(a),
      onClick: H
    }, [
      S.value ? (u(), m(x, {
        key: 0,
        name: c.iconName,
        size: C.value
      }, null, 8, ["name", "size"])) : v("", !0),
      T.value ? $(c.$slots, "default", { key: 1 }) : v("", !0),
      B.value ? (u(), m(x, {
        key: 2,
        name: c.iconName,
        size: C.value
      }, null, 8, ["name", "size"])) : v("", !0)
    ], 10, Q)) : (u(), h("button", {
      key: 1,
      type: "button",
      disabled: i(d),
      class: p(["inline-flex items-center leading-115 gap-x-2 justify-center tracking-1", [w.value, z.value, _.value, k.value]]),
      "data-variant": i(a),
      onClick: E(H, ["prevent"])
    }, [
      S.value ? (u(), m(x, {
        key: 0,
        name: c.iconName,
        size: C.value
      }, null, 8, ["name", "size"])) : v("", !0),
      T.value ? $(c.$slots, "default", { key: 1 }) : v("", !0),
      B.value ? (u(), m(x, {
        key: 2,
        name: c.iconName,
        size: C.value
      }, null, 8, ["name", "size"])) : v("", !0)
    ], 10, A));
  }
}), W = /* @__PURE__ */ g({
  __name: "CompHeading",
  props: {
    field: {},
    tag: { default: "span" },
    size: { default: "m" },
    isStrong: { type: Boolean, default: !1 }
  },
  setup(e) {
    const t = e, { size: n, isStrong: s } = b(t), l = o(() => {
      switch (n.value) {
        case "xs":
          return "text-16 sm:text-18 md:text-20 lg:text-24 leading-140 sm:leading-135 font-400 font-w-100";
        case "s":
          return "text-20 sm:text-22 md:text-24 lg:text-32 leading-135 sm:leading-130 font-400 sm:font-360 font-w-100";
        case "m":
          return s.value ? "text-26 sm:text-28 md:text-32 lg:text-40 leading-130 sm:leading-120 font-560 font-w-100" : "text-26 sm:text-28 md:text-32 lg:text-40 leading-130 sm:leading-120 font-320 font-w-100";
        case "l":
          return "text-32 sm:text-42 md:text-48 lg:text-56 leading-120 font-320 sm:font-260 font-w-100";
        case "xl":
          return "text-40 sm:text-64 md:text-80 lg:text-88 leading-110 sm:leading-115 font-260 font-w-100";
        default:
          return "";
      }
    });
    return (a, r) => (u(), h("div", null, [
      L(i(O), {
        tag: a.tag,
        field: a.field,
        class: p([l.value]),
        "data-heading-size": i(n),
        "data-heading-bold": i(s)
      }, null, 8, ["tag", "field", "class", "data-heading-size", "data-heading-bold"])
    ]));
  }
}), J = ["data-type"], K = /* @__PURE__ */ g({
  __name: "CompTag",
  props: {
    size: { default: "s" },
    isSelected: { type: Boolean, default: !1 },
    isDisabled: { type: Boolean, default: !1 }
  },
  emits: ["handleClick"],
  setup(e, { emit: t }) {
    const n = e, s = t, { size: l, isSelected: a, isDisabled: r } = b(n), d = o(() => {
      switch (l.value) {
        case "xs":
          return "h-6 text-11 font-440";
        case "s":
          return "h-8 text-14 font-400";
        default:
          return "";
      }
    }), f = o(() => {
      if (!r.value)
        return "px-3.5";
    }), y = o(() => {
      if (!r.value)
        return a.value ? "bg-velux-grey-50 border-velux-grey-50" : "hover:bg-velux-grey-400";
    }), k = o(() => r.value || a.value ? "" : "border border-velux-grey-400 cursor-pointer"), z = () => s("handleClick");
    return (w, _) => (u(), h("div", {
      class: p(["text-velux-black gap-x-2 inline-flex items-center uppercase font-w-45 leading-100 tracking-6", [d.value, f.value, y.value, k.value]]),
      onClick: z,
      "data-type": i(l)
    }, [
      !i(r) && !i(a) ? (u(), m(x, {
        key: 0,
        name: "math-symbols-plus",
        size: 10
      })) : v("", !0),
      $(w.$slots, "default"),
      i(a) ? (u(), m(x, {
        key: 1,
        name: "math-symbols-times",
        size: 10
      })) : v("", !0)
    ], 10, J));
  }
}), N = /* @__PURE__ */ Object.freeze(/* @__PURE__ */ Object.defineProperty({
  __proto__: null,
  CompBlockQuote: M,
  CompBody: P,
  CompButton: G,
  CompHeading: W,
  CompTag: K
}, Symbol.toStringTag, { value: "Module" }));
function U(e) {
  for (const t in N)
    e.component(t, N[t]);
}
const ee = { install: U };
export {
  M as CompBlockQuote,
  P as CompBody,
  G as CompButton,
  W as CompHeading,
  K as CompTag,
  ee as default
};
